/***********************************************************
*           Serial interface routines for RxSat            *
*           (C) 2009 by Marius Petrescu, YO2LOJ            *
*       Released under the GNU General Public License      *
***********************************************************/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>

#include "uart.h"

char uart_cmd = 0;
char uart_chan = 0;

void uart_init(void)
{
	/* set baud rate */
	UBRR = _UART_UBRR(1200);
	/* frame format: 1N8, enable receiver, and rxe interrupts */
	UCR = _BV(RXB8)| _BV(RXEN)|_BV(RXCIE);
	/* global enable interrupts */
	sei();
}

/* receive complete interrupt handler */
/* implement RIG RX2 protocol */
SIGNAL (SIG_UART_RECV)
{
	char ch;
	ch = UDR;

	if ((ch == 'S')||(ch == 's'))
	{
		uart_cmd = UART_CMD_SCAN;
	}
	else if ((ch == 'F')||(ch == 'f'))
	{
		uart_cmd = UART_CMD_START;	
	}
	else if ((ch >= UART_MINCHAN) && (ch <= UART_MAXCHAN) && (uart_cmd == UART_CMD_START))
	{
		uart_chan = ch - '0';
		uart_cmd = UART_CMD_DONE;
	}
	else
	{
		uart_cmd = UART_CMD_NONE;
	}
}

